AddDamageType("Duel_ThrowingKnives",   '<bitmap:add-ons/Weapon_Pack_Dueling1Gloves/Throwing_Knives/Dueling_ThrowingKnife_CI> %1',    '%2 <bitmap:add-ons/Weapon_Pack_Dueling1Gloves/Throwing_Knives/Dueling_ThrowingKnife_CI> %1',0.75,1);
datablock ProjectileData(DThrowingKnivesProjectile)
{
   projectileShapeName = "./Throwing_Knife_Projectile.dts";

   directDamage        = 12.5;
   directDamageType  = $DamageType::Duel_ThrowingKnives;
   radiusDamageType  = $DamageType::Duel_ThrowingKnives;
   stickExplosion        = ThrowingKnifesStickExplosion;
   bloodExplosion        = ThrowingKnifesStickExplosion;
   explosion           = ThrowingKnifesExplosion;

   muzzleVelocity      = 65;
   velInheritFactor    = 1;
   explodeOnPlayerImpact = true;
   explodeOnDeath        = true;  

   armingDelay         = 8000;
   lifetime            = 8000;
   fadeDelay           = 8000;
   isBallistic         = true;
   bounceAngle         = 170; //stick almost all the time
   minStickVelocity    = 10;
   bounceElasticity    = 0.2;
   bounceFriction      = 0.01;   
   gravityMod = 1.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "ThrowingKnife Slice";
};

//////////
// item //
//////////
datablock ItemData(ThrowingKnifeGItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Throwing_Knife_Projectile.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Duel_ThrowKnives G";
	iconName = "./Throwing_Knives_Icon";
	doColorShift = true;
	colorShiftColor = "0.471 0.471 0.471 1.000";

	 // Dynamic properties defined by the scripts
	image = ThrowingKnifeGImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(ThrowingKnifeGImage)
{
   // Basic Item properties
   shapeFile = "./Duel_ThowingKnives_Gloves.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "-0.58 -0.75 -0.285"; //X Z Y


   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = 0; //"0.7 1.2 -0.1";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = ThrowingKnifeItem;
   ammo = " ";
   projectile = ThrowingKnifeFastProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = "0.471 0.471 0.471 1.000";

   // Hold down the click to get knife, then throw it!
	stateName[0]                     = "Activate";
	stateSequence[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";

	stateName[1]                     = "Ready";
	stateSequence[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Charge";
	stateAllowImageChange[1]         = true;

	stateName[2]                    = "Charge";
	stateSequence[2]                = "Charge";
	stateTimeoutValue[2]            = 0.35;
	stateTransitionOnTimeout[2]     = "Charged";
	stateWaitForTimeout[2]		= false;
	stateTransitionOnTriggerUp[2]  = "Ready";
	stateAllowImageChange[2]        = false;

	stateName[3]                    = "Charged";
	stateSequence[3]                = "Charged";
	stateTransitionOnTriggerUp[3]  = "Fire_Release";
	stateScript[3]                  = "onCharged";
	stateAllowImageChange[3]        = false;

	stateName[4]                    = "Fire_Release";
	stateSequence[4]                = "Fire_1";
	stateTimeoutValue[4]            = 0.05;
	stateTransitionOnTimeout[4]     = "Fire_ReloadStart";
	stateAllowImageChange[4]        = false;
	stateSound[4]                    = ThrowingKnifeThrowSound;

	stateName[5]                    = "Fire_ReloadStart";
	stateFire[5]                    = true;
	stateSequence[5]                = "Fire_2";
	stateScript[5]                  = "onFire";
	stateTimeoutValue[5]            = 0.1;
	stateTransitionOnTimeout[5]     = "Reload1";
	stateAllowImageChange[5]        = false;

	stateName[6]                    = "Reload1";
	stateSequence[6]                = "Reload_1";
	stateTransitionOnTimeout[6]     = "Reload2";
	stateTimeoutValue[6]            = 0.2;
	stateAllowImageChange[6]        = false;
	stateWaitForTimeout[6]		= true;

	stateName[7]                    = "Reload2";
	stateSequence[7]                = "Reload_2";
	stateTransitionOnTimeout[7]     = "Ready";
	stateTimeoutValue[7]            = 0.5;
	stateAllowImageChange[7]        = false;
	stateWaitForTimeout[7]		= true;

};

function ThrowingKnifeGImage::onFire(%this, %obj, %slot)
{
	
	%projectile = DThrowingKnivesProjectile;
	%spread = 0.00008;
	%shellcount = 1;

	%obj.playThread(3, plant);

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}

function ThrowingKnifeGImage::onCharged(%this, %obj, %slot)
{	
		%obj.playThread(2, plant);
        serverPlay3D(DuelChargedSound,%obj.getPosition());

}

function ThrowingKnifeGImage::onMount(%this, %obj, %slot)
{	

			%obj.hideNode("LHand");
			%obj.hideNode("RHand");
			%obj.hideNode("LHook");
			%obj.hideNode("RHook");
		%obj.playThread(0, armreadyboth);
}

function ThrowingKnifeGImage::onUnMount(%this, %obj, %slot)
{	

			%obj.unhideNode("LHand");
			%obj.unhideNode("RHand");
		%obj.playThread(0, root);
}